<?php
class LegendHelper {
	/**
	*	Contains Icons used during page building
	*/
	static $usedIcons = array();
	
	private static function loadIconByName($name, $value = NULL) {
		$object = new stdClass();
		$object->file = "";
		$object->desc = "";
		if (is_null($value)) {
			switch($name) {
				default:
#					if (is_object($name)) {
#						$object->file = JPATH_ROOT.DIRECTORY_SEPARATOR."administrator".DIRECTORY_SEPARATOR."components".DIRECTORY_SEPARATOR."com_productadvisor".DIRECTORY_SEPARATOR."assets".DIRECTORY_SEPARATOR."icons".DIRECTORY_SEPARATOR.$name->name;
#						$object->desc = $name->desc;
#					} else {
#						return FALSE;
#					}
				break;
			}
		} else {
			switch($name) {
				case "manageitem":
					switch($value) {
						case "add":
							$object->file = JPATH_ROOT.DIRECTORY_SEPARATOR."administrator".DIRECTORY_SEPARATOR."components".DIRECTORY_SEPARATOR."com_productadvisor".DIRECTORY_SEPARATOR."assets".DIRECTORY_SEPARATOR."icons".DIRECTORY_SEPARATOR."add.png";
							$object->desc = JText::_("COM_PRODUCTADVISOR_ADD");
						break;
						case "edit":
							$object->file = JPATH_ROOT.DIRECTORY_SEPARATOR."administrator".DIRECTORY_SEPARATOR."components".DIRECTORY_SEPARATOR."com_productadvisor".DIRECTORY_SEPARATOR."assets".DIRECTORY_SEPARATOR."icons".DIRECTORY_SEPARATOR."pencil.png";
							$object->desc = JText::_("COM_PRODUCTADVISOR_EDIT");
						break;
						case "delete":
							$object->file = JPATH_ROOT.DIRECTORY_SEPARATOR."administrator".DIRECTORY_SEPARATOR."components".DIRECTORY_SEPARATOR."com_productadvisor".DIRECTORY_SEPARATOR."assets".DIRECTORY_SEPARATOR."icons".DIRECTORY_SEPARATOR."delete.png";
							$object->desc = JText::_("COM_PRODUCTADVISOR_DELETE");
						break;
					}
				break;
			}
		}
		$object->icon = self::reformatFileAddress($object->file, "http");
		return $object;
	}
	
	public static function renderMultiIcon($general, $specific, $attr = NULL) {
		$obj = self::loadIconByName($general, $specific);
		if(is_array($attr)) {
			foreach($attr as $k => $v) {
				$obj->$k = $v;
			}
		}
		if (isset($obj->addToLegend) && $obj->addToLegend) {self::setLegendIcon($obj);}
		if (!empty($obj->icon)) {
			return self::renderIcon($obj);
		} else {
			return "<span class=\"flag icon ".strtolower($obj->desc)."\">".$obj->desc."</span>";
		}
	}

	public static function renderIcon($obj, $addToLegend = TRUE) {
		if (is_object($obj)) {
		} else if (is_array($obj)) {
			$obj = (object) $obj;
			$obj = self::loadIconByName($obj);
		} else {
			$obj = self::loadIconByName($obj);
		}
		if (!file_exists($obj->file) || !is_file($obj->file)) {
			return FALSE;
		}
		if ($addToLegend) {self::setLegendIcon($obj);}
		$class = (isset($obj->class)) ? " class=\"".$obj->class."\"" : "";
		return "<img src=\"".$obj->icon."\" alt=\"".$obj->desc."\" title=\"".$obj->desc."\"".$class."/>";
	}
	
	private static function reformatFileAddress($addr, $dest = "http") {
		switch($dest) {
			case "local":
				$addr = str_replace("/", DIRECTORY_SEPARATOR, $addr);
				$addr = str_replace(JURI::root(), JPATH_ROOT.DIRECTORY_SEPARATOR, $addr);
			break;
			default:
			case "http":
				if (file_exists($addr)) {
					$addr = str_replace(JPATH_ROOT.DIRECTORY_SEPARATOR, JURI::root(), $addr);
					$addr = str_replace(DIRECTORY_SEPARATOR, "/", $addr);
				} else {
					$addr = FALSE;
				}
			break;
		}
		return $addr;
	}
	
	public static function setLegendIcon($obj) {
		if (is_object($obj)) {
			if (file_exists($obj->file) && is_file($obj->file)) {
				$outputIMG = TRUE;
			} else {
				$outputIMG = FALSE;
			}
		} else {
			$obj = self::loadIconByName($obj);
		}
		array_push(self::$usedIcons, $obj);
	}
	
	public static function printIconLegend() {
		$return = "";
		$bla2 = self::removeDuplicateLegendIcons();
		#usort($bla2, array ("LegendHelper", "cmp_obj"));
		foreach($bla2 as $obj) {
			if ($tmp = self::renderIcon($obj)) {
				$return .= "<li>".self::renderIcon($obj)."<span>".$obj->desc."</span></li>";
			} 
		}
		if (!empty($return)) {
			return "<ul class=\"legend\">".$return."</ul>";
		} else {
			return FALSE;
		}
	}

	private static function removeDuplicateLegendIcons() {
		$icons = self::$usedIcons;
		$r = array();
		for($i=0; $i<count($icons); $i++) {
			$r[$icons[$i]->icon] = $icons[$i];
		}
		return $r;
	}
	
	

    /* Dies ist die statische Vergleichsfunktion: */
    private function cmp_obj(&$a, &$b)
	{
		$al = strtolower($a->desc);
		$bl = strtolower($b->desc);
		if ($al == $bl) {
			return 0;
		}
		return ($al > $bl) ? +1 : -1;
	}
	
	public static function getAdminIcons($value) {
		#var_dump($value);
		switch(intval($value)) {
			case 0:
				$obj = self::loadIconByName('denied');
			break;
			case 1:
				$obj = self::loadIconByName('accept');
			break;
			case -1:
			break;
			default:
				return FALSE;
			break;
		}
		#print_r($obj);
		return self::renderIcon($obj);
	}
}

?>